import { ElementType } from 'react';
import { DropdownProps } from './types.ts';
declare const Dropdown: {
    <T extends ElementType = "div">(props: DropdownProps<T>): import("react/jsx-runtime").JSX.Element;
    Toggle: {
        <T extends ElementType = "a" | "button">(props: import('./types.ts').DropdownToggleProps<T>): import("react/jsx-runtime").JSX.Element;
        displayName: string;
    };
    Item: {
        <T extends ElementType = "a">(props: import('./types.ts').DropdownItemProps<T>): import("react/jsx-runtime").JSX.Element;
        displayName: string;
    };
    ItemText: {
        <T extends ElementType = "span">(props: import('./types.ts').DropdownItemTextProps<T>): import("react/jsx-runtime").JSX.Element;
        displayName: string;
    };
    Menu: {
        <T extends ElementType = "ul">(props: import('./types.ts').DropdownMenuProps<T>): import("react/jsx-runtime").JSX.Element;
        displayName: string;
    };
    Divider: {
        <T extends ElementType = "hr">(props: import('./types.ts').DropdownDividerProps<T>): import("react/jsx-runtime").JSX.Element;
        displayName: string;
    };
    Header: {
        <T extends ElementType = "div">(props: import('./types.ts').DropdownDividerProps<T>): import("react/jsx-runtime").JSX.Element;
        displayName: string;
    };
    displayName: string;
};
export default Dropdown;
