import { jsxs as x, Fragment as A, jsx as t } from "react/jsx-runtime";
import { u as ne, o as se, s as re, f as ae, a as de } from "../vendor.js";
import { useState as w, useRef as le, useMemo as ie, useCallback as T, useEffect as N } from "react";
import { n as ce, c as pe, g as ue, a as fe, f as me, m as ge, o as he, b as be, i as we } from "../tools/tools.js";
import { D as H } from "./dropdown-divider.js";
import { D as K } from "./dropdown-header.js";
import { D as O } from "./dropdown-item.js";
import { D as q } from "./dropdown-item-text.js";
import { D as z } from "./dropdown-menu.js";
import { D as g } from "./dropdown-toggle.js";
const d = function(G) {
  const {
    as: U = "div",
    autoClose: h = !0,
    btnGroup: k,
    buttonProps: E,
    center: D,
    children: _,
    className: R,
    customMenu: i,
    dropend: y,
    dropOldClass: I,
    dropstart: r,
    dropup: v,
    dropupCenter: C,
    menuProps: a,
    offset: J,
    options: Q,
    split: c,
    strategy: W = "absolute",
    style: S,
    toggle: M,
    toggleProps: s,
    variables: L,
    visible: b,
    ...X
  } = G, Y = (Q ?? []).map((e, n) => ({
    ...e,
    id: e.id ?? n
  })), [Z] = w(Y), [o, p] = w(b ?? !1), u = le(ce()), [F, V] = w(), [B, j] = w(!1), { floatingStyles: $, refs: f } = ne({
    middleware: [
      se(() => J ?? 0, [o]),
      re((e) => e, [o]),
      ae((e) => e, [o]),
      de((e) => e, [o])
    ],
    onOpenChange: p,
    open: o,
    placement: he(
      {
        bottom: D,
        "bottom-end": F === "end",
        "bottom-start": F === "start",
        "left-start": r,
        "right-start": y,
        top: C,
        "top-start": v
      },
      "bottom-start"
    ),
    strategy: W
  }), P = ie(() => {
    const e = pe(
      !I && ue({
        "btn-group": c || k,
        dropdown: !0,
        "dropdown-center": D,
        "dropup-center": C
      }),
      v && "dropup",
      y && "dropend",
      r && "dropstart",
      R
    ), n = fe({ ...L, ...S }, !0, (l, oe) => be(oe));
    return me(
      {
        className: e,
        style: n
      },
      we
    );
  }, [k, D, R, I, y, r, v, C, c, S, L]), m = T(
    (e) => {
      var n;
      p(typeof e == "boolean" ? e : e ? !o : !1), (n = s == null ? void 0 : s.onClick) == null || n.call(
        s,
        e
      );
    },
    [o, s == null ? void 0 : s.onClick]
  ), ee = T(() => {
    i && j(!0);
  }, [i]), te = T(() => {
    i && j(!1);
  }, [i]);
  return N(() => {
    typeof b == "boolean" && p(b);
  }, [b]), N(() => {
    if (!h || B)
      return;
    const e = (n) => {
      const l = n.target;
      if (l.className.includes("dropdown")) {
        if (h === "outside")
          return;
        l.dataset.toggleId !== u.current && m();
      } else h !== "inside" && m();
    };
    return document.body.addEventListener("click", e), () => document.body.removeEventListener("click", e);
  }, [h, B, m]), N(() => {
    var n;
    if (!a || !((n = a.className) != null && n.includes("dropdown-menu-")))
      return;
    const e = f.floating.current;
    if (e) {
      const l = getComputedStyle(e).getPropertyValue("--bs-position");
      V(l || !1);
    }
  }, [a, f.floating]), /* @__PURE__ */ x(U, { ...X, ...P, children: [
    c ? /* @__PURE__ */ x(A, { children: [
      !(c && r) && /* @__PURE__ */ t(g, { dropOldClass: !0, ...E, children: M }),
      /* @__PURE__ */ t(
        g,
        {
          "aria-expanded": o ? "true" : "false",
          className: "dropdown-toggle-split",
          show: o,
          ...s,
          "data-toggle-id": u.current,
          onClick: m,
          onRef: f.setReference,
          children: /* @__PURE__ */ t("span", { className: "visually-hidden", children: "Toggle Dropdown" })
        }
      )
    ] }) : /* @__PURE__ */ x(
      g,
      {
        "aria-expanded": o ? "true" : "false",
        show: o,
        ...s,
        "data-toggle-id": u.current,
        onClick: m,
        onRef: f.setReference,
        children: [
          r && /* @__PURE__ */ t("span", { className: "dropdown-nbsp", "data-toggle-id": u.current, children: " " }),
          M,
          !r && /* @__PURE__ */ t("span", { className: "dropdown-nbsp", "data-toggle-id": u.current, children: " " })
        ]
      }
    ),
    /* @__PURE__ */ t(
      z,
      {
        ...ge(a, { style: { ...a == null ? void 0 : a.style, ...$ } }),
        onMouseEnter: ee,
        onMouseLeave: te,
        onRef: f.setFloating,
        show: o,
        children: i ? _ : /* @__PURE__ */ t(A, { children: Z.map((e) => e.header ? /* @__PURE__ */ t(K, { children: e.header }, e.id) : e.itemText ? /* @__PURE__ */ t(q, { children: e.itemText }, e.id) : e.divider ? /* @__PURE__ */ t(H, {}, e.id) : e.as === "a" ? /* @__PURE__ */ t(O, { active: e.active, as: "a", disabled: e.disabled, href: e.href, children: e.item }, e.id) : /* @__PURE__ */ t(O, { active: e.active, as: "button", disabled: e.disabled, children: e.item }, e.id)) })
      }
    ),
    c && r && /* @__PURE__ */ t(g, { dropOldClass: !0, ...E, children: M })
  ] });
};
d.Toggle = g;
d.Item = O;
d.ItemText = q;
d.Menu = z;
d.Divider = H;
d.Header = K;
d.displayName = "BRL.Dropdown";
export {
  d as D
};
//# sourceMappingURL=dropdown.js.map
