import { jsxs as c, jsx as a } from "react/jsx-runtime";
import { u as Y, b as Z, c as ee, d as te, F as se, a as ae } from "../vendor.js";
import { useState as M, useMemo as d, useCallback as P, useEffect as ne, Fragment as B } from "react";
import { t as k, u as oe, v as le, c as ie, a as re, f as ce, p as F, d as r, b as de, i as pe } from "../tools/tools.js";
import { s as h } from "./select-multiple.module.js";
const ue = function(j) {
  const {
    as: $ = "div",
    className: g,
    contentClasses: b,
    disabled: p,
    dropOldClass: x,
    hideActiveOptions: A,
    onChange: u,
    options: H,
    placeholder: y,
    selectableCount: m,
    single: f,
    style: C,
    variables: O,
    ...R
  } = j, V = (H ?? []).map((e, t) => ({
    ...e,
    id: e.id ?? t
  })), L = k(b, ["optionItem", "selectButton"], !0), W = k(b, ["optionItem", "selectButton"]), [N, q] = M(!1), [o, z] = M(V), { context: w, floatingStyles: E, refs: S } = Y({
    middleware: [
      ae({
        apply({ availableHeight: e, elements: t, rects: s }) {
          Object.assign(t.floating.style, {
            maxHeight: `${Math.max(0, e)}px`,
            minWidth: `${s.reference.width}px`
          });
        }
      })
    ],
    onOpenChange: q,
    open: N
  }), G = Z(w, {
    enabled: !p
  }), K = ee(w), { getFloatingProps: T, getReferenceProps: U } = te([G, K]), _ = d(() => o.some((e) => oe(e.header, !0)), [o]), D = d(() => le(o, "header"), [o]), i = d(() => {
    if (f) {
      const e = o.find((t) => t.active);
      return e ? [e] : [];
    } else
      return o.filter((e) => e.active);
  }, [o, f]), I = d(() => i.length, [i.length]), v = P(
    (e) => {
      z((t) => t.map((s, l) => ({
        ...s,
        active: f ? l === e : l === e ? !s.active : s.active
      })));
    },
    [f]
  ), J = P(
    (e) => {
      const t = o.findIndex((s) => s.id === e.id);
      t !== -1 && v(t);
    },
    [v, o]
  ), Q = d(() => {
    const e = ie(
      !x && `form-select ${h.brlMinH38px}`,
      p && "bg-body-secondary",
      g
    ), t = re({ ...O, ...C }, !0, (s, l) => de(l));
    return ce(
      {
        className: e,
        style: t,
        tabIndex: p ? void 0 : 0
      },
      pe
    );
  }, [x, p, g, O, C]), n = F(L, {
    activeOption: r(
      null,
      "d-flex align-items-center badge text-bg-secondary",
      h.brlCursorDefault
    ),
    bottomDivider: "dropdown-divider",
    clearIcon: r(null, "bi bi-x", h.brlCursorPointer),
    countDisplay: r(
      null,
      "align-self-center flex-shrink-0 text-secondary",
      h.brlScale75
    ),
    floatingMenu: "overflow-y-auto dropdown-menu rounded-3 shadow show",
    header: "dropdown-header",
    mainContainer: r(
      null,
      typeof m == "number" && "d-flex flex-wrap justify-content-between gap-2"
    ),
    optionsContainer: "d-flex flex-wrap column-gap-2 row-gap-1",
    placeholder: "text-secondary user-select-none",
    topDivider: "dropdown-divider"
  });
  return ne(() => {
    u == null || u(i.map((e) => e.id));
  }, [i, u]), /* @__PURE__ */ c($, { ...U(), ...R, ...Q, ref: S.setReference, children: [
    /* @__PURE__ */ c("div", { className: n.mainContainer, "data-slot-main-container": "", children: [
      /* @__PURE__ */ a("div", { className: n.optionsContainer, "data-slot-options-container": "", children: y && i.length === 0 ? /* @__PURE__ */ a("div", { className: n.placeholder, "data-slot-placeholder": "", children: y }) : i.map((e) => /* @__PURE__ */ c("div", { className: n.activeOption, "data-slot-active-option": "", children: [
        e.text,
        /* @__PURE__ */ a(
          "i",
          {
            className: n.clearIcon,
            "data-slot-clear-icon": "",
            onClick: (t) => {
              t.stopPropagation(), J(e);
            },
            tabIndex: -1
          }
        )
      ] }, e.id)) }),
      typeof m == "number" && /* @__PURE__ */ a(
        "div",
        {
          className: n.countDisplay,
          "data-slot-count-display": "",
          children: `${I} / ${m}`
        }
      )
    ] }),
    N && /* @__PURE__ */ a(se, { children: /* @__PURE__ */ a(
      "ul",
      {
        "data-slot-floating-menu": "",
        ref: S.setFloating,
        ...T(),
        className: n.floatingMenu,
        style: E,
        children: D.keys.map((e) => /* @__PURE__ */ c(B, { children: [
          _ && /* @__PURE__ */ a("li", { children: /* @__PURE__ */ a("h6", { className: n.header, "data-slot-header": "", children: e }) }, e),
          D.groupedData[e].map(({ index: t, item: s }) => {
            const l = F(W, {
              optionItem: r(null, s.active && A && "visually-hidden"),
              selectButton: r(
                null,
                "dropdown-item",
                s.active && "active",
                (s.disabled || m === I) && "disabled"
              )
            });
            return /* @__PURE__ */ c(B, { children: [
              s.divider === "top" && /* @__PURE__ */ a("li", { children: /* @__PURE__ */ a("hr", { className: n.topDivider, "data-slot-top-divider": "" }) }),
              /* @__PURE__ */ a("li", { className: l.optionItem, "data-slot-option-item": "", children: /* @__PURE__ */ a(
                "button",
                {
                  className: l.selectButton,
                  "data-slot-select-button": "",
                  onClick: (X) => {
                    X.stopPropagation(), v(t);
                  },
                  type: "button",
                  children: s.text
                }
              ) }),
              s.divider === "bottom" && /* @__PURE__ */ a("li", { children: /* @__PURE__ */ a("hr", { className: n.bottomDivider, "data-slot-bottom-divider": "" }) })
            ] }, s.id);
          })
        ] }, e))
      }
    ) })
  ] });
};
ue.displayName = "BRL.SelectMultiple";
export {
  ue as S
};
//# sourceMappingURL=select-multiple.js.map
