import { ElementType } from 'react';
import { AlertProps } from './types.ts';
declare const Alert: {
    <T extends ElementType = "div">(props: AlertProps<T>): false | import("react/jsx-runtime").JSX.Element;
    Link: {
        <T extends ElementType = "a">(props: import('./types.ts').AlertLinkProps<T>): import("react/jsx-runtime").JSX.Element;
        displayName: string;
    };
    Heading: {
        <T extends ElementType = "div">(props: import('./types.ts').AlertHeadingProps<T>): import("react/jsx-runtime").JSX.Element;
        displayName: string;
    };
    displayName: string;
};
export default Alert;
